var item_record_fields = ["name", "phone", "latitude", "longitude"];

Ext.namespace("App");

Ext.regModel('news', {
	fields: ['id','description','feature','link','target','header_image', 'header_height', 'subcategories'].concat(item_record_fields)
});
var _tabs;
function f() {
  _tabs.setActiveItem(0);
}

function myclone(obj) {
  var newObj = (obj instanceof Array) ? [] : {};
  for (i in obj) {
    if (i == 'clone') continue;
    if (obj[i] && (obj[i] instanceof Array)) {
      newObj[i] = myclone(obj[i]);
    } else newObj[i] = obj[i]
  } return newObj;
}; 

App.Main = Ext.extend(Object, {
	getMainTitle:function(){
		return {
			xtype: 'toolbar', dock: 'top', scroll: 'horizontal',title:'MyMobile App',
			items:[{
				xtype:'button',text:'Back',ui:'back',
				handler:function(){
				},
				scope:this
			}]
		};
	},

	getTabPanel:function(){
		if (has_social) {
			social_tab = [app.social.getSocialPanel()];
		} else {
			social_tab = [];
		}
		
		if (has_donate) {
			donate_tab = [this.getDonatePanel()];
	    } else {
			donate_tab = [];
		}
		tab_list = [this.getHomePanel()].concat(donate_tab).concat([this.getSearchPanel(),app.favorites.getFavoritesPanel()]).concat(social_tab).concat([this.getAboutPanel()]);
		_tabs =  this.uxtab?this.uxtab:this.uxtab=new Ext.TabPanel({
			tabBar: {
	            dock: 'bottom',
	            layout: {
					type: 'hbox',
	                pack: 'center'
		         }
	        },
	        ui: 'light',
	        defaults: {
	            scroll: 'vertical'
	        },
	        fullscreen: true,		        
	        items: tab_list			
		});
	  return _tabs;
	},
	
	getDonatePanel:function(){
		return new Ext.Panel({
 
			listeners:{
	         			activate : function(panel){     
	         			var t=setTimeout("f()",100);    				
         				window.plugins.childBrowser.showControllableWebPage(donate_url,true);
            			return false;
         			}
      		},
			iconCls: 'donate', 
			title: 'Donate',
			layout:'fit'

		});
	},
	
	getSearchPanel:function(){
		return this.searchPanel?this.searchPanel:this.searchPanel=app.search.getSearchPanel();
	},
	
	getAboutPanel:function(){
		return this.aboutpanel?this.aboutpanel:this.aboutpanel=new Ext.Panel({
			iconCls: 'info',
			title: 'About',
			flex: 1,
			scroll:'vertical',
			contentEl: 'layer'
		});
	},
	
	getHomePanel:function(){
		return this.homeIndex?this.homeIndex:this.homeIndex=new Ext.Panel({
			scroll: 'none',
			iconCls: 'bookmarks',
			title: 'Home',
			layout:{type:'vbox',align:'stretch',pack:'start'},
			items:[
			       this.getTitlePanel(),
			       this.getViewPort()
			 ]
		});
	},
	
	getTitlePanel: function(){
		return this.titlepanel?this.titlepanel:this.titlepanel=new Ext.Panel({
			height:banner_height,
			items: [
			        {
			        	html: "<img src=./img/logo.jpg>"
			        }
				]
		});
	},
	
	getTitlePanel2: function(){
		return this.titlepanel2?this.titlepanel2:this.titlepanel2=new Ext.Panel({
			flex: 1,
			items: [
			        {
			        	autoLoad :{
			        		url: "about.html",
							scripts:true
						}
			        }
				]
		});
	},
	
	getViewPort:function(){
	var iconTpl = new Ext.XTemplate.from('list-icon', {compiled: true});
	var noiconTpl = new Ext.XTemplate.from('list', {compiled: true});
	var titleTpl = new Ext.XTemplate.from('list-title', {compiled: true});
	App.mainTpl = new Ext.XTemplate(
  							'<tpl for=".">',
							    '<div class="container">',
 						        '{[this.renderItem(values)]}',
						    '</div>',
  							'</tpl>',
  					{
    					renderItem: function(values) {
						      if (values.icon_image) {
        							return iconTpl.apply(values);
      						  } else if (values.target == 'title') {
      						         return titleTpl.apply(values);      						  
      						  } else {
        							return noiconTpl.apply(values);
      						  }
    					}
  					 }
		);
	
	
		return this.viewport?this.viewport:this.viewport=new Ext.List({
			flex:1,
			style:'background-color:#A9A9A9',
			scroll:'vertical',
	        monitorResize : true,
	        singleSelect: true,
	        store: this.getTopNewsStore(),
	        itemTpl: App.mainTpl,
	        itemSelector: 'div.contact',
	        listeners:{
				itemtap: function(obj, index, item, e)
				{
					var record = obj.store.getAt(index);
					app.titlename = record.get("name");
					app.header_image = record.get("header_image");
					app.active_record = record;
					var id = record.get("id");
					var target = record.get("target");
					var link = record.get("link");
					if("itemlist"==target)
					{
						app.modeldata.getItemList(link);
						_panel = app.secondlevel.getSecondLevelPanel();
						_panel.show();
						panel_stack.push(_panel);
						
						_tabpanel.hide();
						
					}
					else if("feature" == target)
					{
						app.modeldata.getFeature(link);
						_panel = app.feature.getFeaturePanel();
						
						_panel.show();
						panel_stack.push(_panel);
						
						_tabpanel.hide();
						
					}
					else if("drilldown" == target)
					{
						app.modeldata.getDrilldownList(link);
						_panel = app.drilldown.getDrilldownPanel();
						
						_panel.show();
						panel_stack.push(_panel);
						_tabpanel.hide();
						
					}
					else if("item" == target)
					{
						//app.modeldata.getItemDetails(link);
						//app.item.getItemPanel().show();
                        window.plugins.childBrowser.showItemDetail(record.get("id"), link, record);
					}
				},
				afterrender: function(obj)
				{
					app.modeldata.loadCategories();
				}
			}
		}); 
	},
	
	getTopNewsStore:function(){
		return this.topnewsstore ?this.topnewsstore:this.topnewsstore=new Ext.data.Store({
			model: 'news'
		});
	}
	
});