
Ext.regModel('searchresults', {
	fields: ['id','name','teaser','content_url','link']
});

App.Search = Ext.extend(Object, {
	
	getSearchPanel:function(){
		return this.searchPanel?this.searchPanel:this.searchPanel=new Ext.Panel({
			dockedItems: [{
				xtype:'toolbar',dock:'top', 
				height:40,
				layout:'hbox',
				//defaults:{flex:1},
				items:[{
					xtype:'textfield',
					placeHolder:'Search',
					id: 'searchtextfield',
					componentCls: 'searchstyle',
					width: 200

				},
				{
					xtype:'spacer'
				},
				{
					xtype:'button',text:'Search',ui:'action',
					handler:function(){
						var query = Ext.getCmp("searchtextfield").getValue();
						app.modeldata.loadSearchResults(query);
					},
					scope:this
				}]
			}],
			iconCls: 'search', 
			title: 'Search',
			layout:'fit',
			items:[
			       this.getSearchResultPanel()
			      ]
		});
	},


	getSearchResultStore:function(){
		return this.searchResultStore?this.searchResultStore:this.searchResultStore = new Ext.data.Store({
			model: 'searchresults'
		});
	},
	
	getSearchResultPanel:function(){
		return this.searchResultPanel?this.searchResultPanel:this.searchResultPanel=new Ext.List({
			style:'background-color:#A9A9A9',
	        monitorResize : true,
	        singleSelect: true,
			scroll:'vertical',
			emptyText: 'No Record Found',
	        store: this.getSearchResultStore(),
	        itemTpl: new Ext.XTemplate.from('tpl_searchlist', {compiled: true}),
	        itemSelector: 'div.contact',
	        listeners:{
				itemtap: function(obj, index, item, e)
				{
					var record = obj.store.getAt(index);
					var link = record.get("link");
					app.titlename = record.get("name");
					window.plugins.childBrowser.showItemDetail(record.get("id"), link, record);
				}				
			}
		}); 
	}

})